# Docs specify a username with a capital G at the beginning, but older
# RedHat doesn't allow that. Try to accomodate...

%if "%{_dist}" == "rh7" || "%{_dist}" == "rh8"|| "%{_dist}" == "rh9" || "%{_dist}" == "centos2-i386"
%define userPrefix g
%else
%define userPrefix G
%endif

%define LogUser   %{userPrefix}dnslog
%define CacheUser %{userPrefix}dnscache
%define TinyUser  %{userPrefix}tinydns
%define RblUser   %{userPrefix}rbldns
%define WallUser  %{userPrefix}walldns

%define usedietlibc %{?_without_dietlibc: 0} %{?!_without_dietlibc: 1}

# group ownership
%define DjbGroup daemon


#######################################################################

Name: djbdns
Version: 1.05
Release: 16%{?dist}
Summary: a collection of Domain Name System tools

Group: System Environment/Daemons
License: Public Domain
URL:     http://cr.yp.to/%{name}.html
Source0: http://cr.yp.to/%{name}/%{name}-%{version}.tar.gz
Source1: http://smarden.sunsite.dk/pape/djb/manpages/%{name}-%{version}-man-20031023.tar.gz
Source2: http://riemann.fmi.uni-sofia.bg/vladov/ftp/qmail+djbdns.tar.gz
Source4: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscache-showctl
Source5: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/tinydns-showctl
Source6: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnsqrx
Source7: http://replay.waybackmachine.org/20060426080558/http://efge.free.fr/djbdns/prettycache.pl

Source8: djbdns.run
Source9: djbdns.logrun

Source10: djbdnsctl.txt

Source11: djbdns.dnscache.run
Source12: djbdns.dnscache.sysconfig

Source21: djbdns.axfrdns.run
Source22: djbdns.axfrdns.sysconfig

Source31: djbdns.tinydns.run
Source32: djbdns.tinydns.sysconfig

Source33: djbdns.tinydns.add-alias
Source34: djbdns.tinydns.add-childns
Source35: djbdns.tinydns.add-host
Source36: djbdns.tinydns.add-mx
Source37: djbdns.tinydns.add-ns

Source41: djbdns.rbldns.run
Source42: djbdns.rbldns.sysconfig

Source51: djbdns.walldns.run
Source52: djbdns.walldns.sysconfig


BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
%if %{?usedietlibc}
BuildRequires: dietlibc
%endif

# This patch fixes the errno issue in daemontools because DJB is too much 
# of an ass to admit his software has a bug.
Patch0: djbdns.errno.patch

# Make installation easier...
Patch1: djbdns.hier.patch

# Allow extended format data lines
Patch2: http://www.jms1.net/djbdns/djbdns-1.05-rbldns.patch

# Make tools less dumb
Patch3: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscacheip-space-separator.patch

# Make .tmp files not conflict with cdb compiler .tmp files
Patch4: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/compiler-temporary-filename.patch

# Fix dnscache CNAME issues
Patch5: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscache-cname-handling.patch

# Fix dnscache forwardonly loop issues
Patch6: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnscache-strict-forwardonly.patch

# Fix semantic errors with tinydns
Patch7: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/tinydns-data-semantic-error.patch

# More tinydns crap
Patch8: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/tinydns-alias-chain-truncation.patch

# Update dnsroots.global file
Patch9: http://projects.standblue.net./docs/dnsroots.global.patch

# Add a "dnsnamex" command to report all domains an IP maps to
Patch10: http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/dnsnamex.patch

# Patch dnsroots.global with updated root NS info
Patch11: djbdns.dnsroots.global.patch

# Allow dumping of dnscache on signal, to prevent misses on restart
Patch12: http://riemann.fmi.uni-sofia.bg/programs/djbdns-dumpcache.patch


%description
djbdns is a collection of command-line Domain Name System tools.

To install a djbdns server, like dnscache or tinydns, you'll need to 
separately install the relevant subpackage.

#######################################################################
%package dnslog
Provides:	dnslog = %{version}-%{release}
Summary:	a dedicated user account for DNS server logging
Group:		System Environment/Daemons
Requires:	djbdns%{?_isa} = %{version}-%{release}

%description dnslog
dnslog contains the %{LogUser} user which certain djbdns servers use
to reduce privileges when writing out log files.

You only need to install this package if you're running a djbdns daemon
like dnscache or tinydns.


#######################################################################
%package dnscache
Summary: 	a small and fast caching DNS server
Group: 		System Environment/Daemons
URL:		http://cr.yp.to/djbdns/dnscache.html
Provides: 	dnscache = %{version}-%{release}
Requires:	djbdns%{?_isa} = %{version}-%{release}, djbdns-dnslog%{?_isa} = %{version}-%{release}
Requires(pre): 	djbdns-dnslog%{?_isa} = %{version}-%{release}
Requires: 	daemontools
Requires(post): daemontools

%description dnscache
dnscache is a DNS cache. It accepts recursive DNS queries from local 
clients such as web browsers and mail transfer agents. It collects 
responses from remote DNS servers. It caches the responses to save time 
later.


#######################################################################
%package tinydns
Summary: 	a small and fast DNS server
Group: 		System Environment/Daemons
URL:		http://cr.yp.to/djbdns/tinydns.html
Provides: 	tinydns = %{version}-%{release}
Requires: 	djbdns-dnslog%{?_isa} = %{version}-%{release}, djbdns%{?_isa} = %{version}-%{release}
Requires(pre): 	djbdns-dnslog%{?_isa} = %{version}-%{release}
Requires: 	daemontools ucspi-tcp
Requires(post): daemontools

%description tinydns
tinydns does authoritative nameserving via UDP only; it does not do 
recursive nameserving, nor does it answer TCP queries (axfrdns does 
that).

The only hosts that should ask tinydns for a host are recursive 
nameservers, such as those found in /etc/resolv.conf, like djbdns or 
BIND. Tinydns should never be listed in /etc/resolv.conf.

Tinydns interoperates properly with every authoritative and recursive 
nameserver I know of, and supporting all the standards needed to do so.


#######################################################################
%package axfrdns
Summary: 	a small and fast DNS zone-transfer server
Group:		System Environment/Daemons
URL:		http://cr.yp.to/djbdns/axfrdns.html
Provides: 	axfrdns = %{version}-%{release}
Requires: 	djbdns-dnslog%{?_isa} = %{version}-%{release}, djbdns-tinydns%{?_isa} = %{version}-%{release}, djbdns%{?_isa} = %{version}-%{release}
Requires(pre): 	djbdns-dnslog%{?_isa} = %{version}-%{release}, djbdns-tinydns%{?_isa} = %{version}-%{release}
Requires: 	daemontools ucspi-tcp
Requires(post): daemontools

%description axfrdns
axfrdns reads a zone-transfer request in DNS-over-TCP format from its 
standard input, and responds with locally configured information. 

You will need to install tinydns first to use this program.


#######################################################################
%package rbldns
Summary: 	a realtime blackhole DNS server
Group: 		System Environment/Daemons
URL:		http://cr.yp.to/djbdns/rbldns.html
Provides: 	rbldns = %{version}-%{release}
Requires: 	djbdns-dnslog%{?_isa} = %{version}-%{release}, djbdns%{?_isa} = %{version}-%{release}
Requires(pre): 	djbdns-dnslog%{?_isa} = %{version}-%{release}
Requires: 	daemontools
Requires(post): daemontools

%description rbldns
rbldns is an IP-address-listing DNS server. It accepts iterative DNS 
queries from hosts around the Internet asking about various IP addresses. 
It provides responses showing whether the addresses are on a locally 
configured list, such as RBL or DUL.


#######################################################################
%package walldns
Summary: 	a reverse DNS wall
Group: 		System Environment/Daemons
URL:		http://cr.yp.to/djbdns/walldns.html
Provides: 	walldns = %{version}-%{release}
Requires: 	djbdns-dnslog%{?_isa} = %{version}-%{release}, djbdns%{?_isa} = %{version}-%{release}
Requires(pre): 	djbdns-dnslog%{?_isa} = %{version}-%{release}
Requires: 	daemontools
Requires(post): daemontools

%description walldns
walldns is a reverse DNS wall. It accepts iterative DNS queries for 
in-addr.arpa domains from hosts around the Internet, and supplies 
generic responses that avoid revealing local host information.

walldns provides a PTR record for 4.3.2.1.in-addr.arpa showing 
4.3.2.1.in-addr.arpa as the name of IP address 1.2.3.4, and a matching A 
record showing 1.2.3.4 as the IP address of 4.3.2.1.in-addr.arpa.


#######################################################################
%prep
%setup -q
%patch0
%patch1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p2
%patch10 -p2
%patch11
#%patch12

tar -xzvf %{SOURCE1}
tar -xzvf %{SOURCE2}

%{__perl} -pi -e "s#/usr/local#%{_prefix}#g" *
%{__perl} -pi -e "s#outs\(auto_home\); outs\(\"/bin#outs(auto_home); outs(\"/sbin#g" *
%{__perl} -pi -e "s#\"bin\"#\"usr/sbin\"#g" hier.c


%build
echo %{_prefix} > conf-home

# Fix DJB errno.h issue
echo "gcc -O2 -include /usr/include/errno.h" > conf-cc
%if %{?usedietlibc}
    echo "diet -v -Os gcc -DREALLY_SMALL -finline-functions -g -Wall -Os" > conf-cc
    echo "diet -v -Os gcc -DREALLY_SMALL -finline-functions -g -Wall -Os" > conf-ld
%else
    echo "gcc -DREALLY_SMALL -finline-functions -Os" > conf-cc
    echo "gcc -s" > conf-ld
%endif

make

# Only build this if qmail is actually present in our BUILD directory,
# since it requires use of qmail libs

if [ -d ../qmail-1.03 ] ; then
   make -f Makefile.qmail
fi


%install
rm -fR %{buildroot}
install -d %{buildroot}/bin
install -d %{buildroot}/sbin
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_sysconfdir}

rm -f install instcheck auto_home.c auto_home.o
echo %{buildroot} > conf-home
make install instcheck

./install
./instcheck

install -d %{buildroot}%{_mandir}/man{1,5,8}
install djbdns-man/*.1 %{buildroot}%{_mandir}/man1/
install djbdns-man/*.5 %{buildroot}%{_mandir}/man5/
install djbdns-man/*.8 %{buildroot}%{_mandir}/man8/
install djbdns-man/README README.man

# Install our djbdns convenience init script
install -d %{buildroot}%{_initrddir}
install -m 755 %{SOURCE10} %{buildroot}%{_initrddir}/djbdns
%{__ln_s} %{_initrddir}/djbdns  %{buildroot}%{_sbindir}/djbdnsctl

# Move some dnslookup and testing utils from /usr/sbin to /bin
for THIS in dnsip dnsipq dnsmx dnsname dnsq dnsqr dnstxt
do
  mv %{buildroot}/%{_sbindir}/$THIS %{buildroot}/bin/$THIS
done

# Move admin tools to /sbin
for THIS in dnstrace dnstracesort random-ip
do
  mv %{buildroot}/%{_sbindir}/$THIS %{buildroot}/sbin/$THIS
  %{__ln_s} /sbin/$THIS %{buildroot}%{_sbindir}/$THIS
done

mv %{buildroot}/%{_sbindir}/dnsfilter %{buildroot}/bin/dnsfilter
%{__ln_s} /bin/dnsfilter %{buildroot}%{_sbindir}/dnsfilter
%{__ln_s} /bin/dnsfilter %{buildroot}/sbin/dnsfilter


# touch a dnsrewrite file for later ghosting (see man qualification)
touch %{buildroot}%{_sysconfdir}/dnsrewrite

# pickdns is obsolete. Don't package it
rm -f %{buildroot}%{_sbindir}/pickdns*


#######################################################################
#######################################################################
# Common setup for all sub-packages
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_localstatedir}/%{name}
install -m 644 %{SOURCE9} djbdns.logrun
%{__perl} -pi -e "s/LOGUSER/%{LogUser}/g;" djbdns.logrun

SVCROOT="%{_localstatedir}/%{name}"

for THISSVC in dnscache axfrdns tinydns rbldns walldns
do
 # Create service and log directories
    install -d 							%{buildroot}%{_localstatedir}/log/${THISSVC}
    install -d 							%{buildroot}%{_localstatedir}/lib/${THISSVC}
    install -d 			  				%{buildroot}${SVCROOT}/${THISSVC}/log
done

install -m 755 %{SOURCE11} %{buildroot}${SVCROOT}/dnscache/run
install -m 755 %{SOURCE21} %{buildroot}${SVCROOT}/axfrdns/run
install -m 755 %{SOURCE31} %{buildroot}${SVCROOT}/tinydns/run
install -m 755 %{SOURCE41} %{buildroot}${SVCROOT}/rbldns/run
install -m 755 %{SOURCE51} %{buildroot}${SVCROOT}/walldns/run

install -m 644 %{SOURCE12} %{buildroot}%{_sysconfdir}/sysconfig/dnscache
install -m 644 %{SOURCE22} %{buildroot}%{_sysconfdir}/sysconfig/axfrdns
install -m 644 %{SOURCE32} %{buildroot}%{_sysconfdir}/sysconfig/tinydns
install -m 644 %{SOURCE42} %{buildroot}%{_sysconfdir}/sysconfig/rbldns
install -m 644 %{SOURCE52} %{buildroot}%{_sysconfdir}/sysconfig/walldns


for THISSVC in dnscache axfrdns tinydns rbldns walldns
do
    install -m 755 djbdns.logrun  				%{buildroot}${SVCROOT}/${THISSVC}/log/run
    %{__perl} -pi -e "s/SERVICENAME/$THISSVC/g;" -e "s/USER/%{userPrefix}$THISSVC/g;" \
	%{buildroot}%{_localstatedir}/%{name}/${THISSVC}/log/run \
	%{buildroot}%{_localstatedir}/%{name}/${THISSVC}/run
done


#######################################################################
# Do the setup for an initial instance of dnscache
install -d %{buildroot}%{_localstatedir}/cache/dnscache
install -d %{buildroot}%{_localstatedir}/lib/dnscache/ip
install -d %{buildroot}%{_localstatedir}/lib/dnscache/servers

# Some sensible defaults
pushd %{buildroot}%{_localstatedir}/lib/dnscache/ip/
    touch 0 10 127 169.254 172.{16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31} 192.168 
popd

cp -fp %{buildroot}%{_sysconfdir}/dnsroots.global %{buildroot}%{_localstatedir}/lib/dnscache/servers/@
touch %{buildroot}%{_sysconfdir}/dnsroots.local

# Touch cache file for later ghosting
%{__ln_s} %{_localstatedir}/cache/dnscache %{buildroot}%{_localstatedir}/lib/dnscache/dump
touch %{buildroot}%{_localstatedir}/cache/dnscache/cache.data


#######################################################################


#######################################################################
# Do the setup for an initial instance of axfrdns to point to tinydns
install -d %{buildroot}%{_sysconfdir}/tcprules.d

# Some sensible defaults
echo "# sample line:  1.2.3.4:allow,AXFR=\"heaven.af.mil/3.2.1.in-addr.arpa\"
# for more, see: http://cr.yp.to/djbdns/tcp.html
# note: removing AXFR= will allow that connection to transfer all local zones
127.:allow
:allow,AXFR=\"\"" 				> %{buildroot}%{_sysconfdir}/tcprules.d/axfrdns
touch				%{buildroot}%{_sysconfdir}/tcprules.d/axfrdns.cdb

# axfrdns uses tinydns's files to transfer
rmdir %{buildroot}%{_localstatedir}/lib/axfrdns

#######################################################################


#######################################################################
# Do the setup for an initial instance of tinydns

# Some sensible defaults
echo "=localhost.localdomain:127.0.0.1:86400" > %{buildroot}%{_localstatedir}/lib/tinydns/data
touch						%{buildroot}%{_localstatedir}/lib/tinydns/data.cdb
echo "%{_localstatedir}/lib/tinydns/data.cdb: %{_localstatedir}/lib/tinydns/data
	/usr/sbin/tinydns-data" > %{buildroot}%{_localstatedir}/lib/tinydns/Makefile

# Install convenience scripts
install -m 755 %{SOURCE33} %{buildroot}%{_sbindir}/add-alias
install -m 755 %{SOURCE34} %{buildroot}%{_sbindir}/add-childns
install -m 755 %{SOURCE35} %{buildroot}%{_sbindir}/add-host
install -m 755 %{SOURCE36} %{buildroot}%{_sbindir}/add-mx
install -m 755 %{SOURCE37} %{buildroot}%{_sbindir}/add-ns

#######################################################################


#######################################################################
# Do the setup for an initial instance of rbldns

# Some sensible defaults
echo ":127.0.0.2:RBL.localdomain\n127.0.0.2:127.0.0.2:Test entry" > %{buildroot}%{_localstatedir}/lib/rbldns/data
touch %{buildroot}%{_localstatedir}/lib/rbldns/data.cdb
echo "%{_localstatedir}/lib/rbldns/data.cdb: %{_localstatedir}/lib/rbldns/data
	/usr/sbin/rbldns-data" > %{buildroot}%{_localstatedir}/lib/rbldns/Makefile

#######################################################################


#######################################################################
# Do the setup for an initial instance of walldns

# Nothing here

#######################################################################


%clean
rm -fr  %{buildroot}


#######################################################################
#######################################################################
%pre dnslog
if [ -z "`id -u %{LogUser} 2>/dev/null`" ]; then
	/usr/sbin/useradd -c "djbdns Logger"  -d "%{_localstatedir}/log" -g "%{DjbGroup}" -M -s /sbin/nologin "%{LogUser}" 2>/dev/null			|| :
fi

%pre dnscache
if [ -z "`id -u %{CacheUser} 2>/dev/null`" ]; then
	/usr/sbin/useradd -c "djbdns Cache"  -d "%{_localstatedir}/lib/dnscache" -g "%{DjbGroup}" -M -s /sbin/nologin "%{CacheUser}" 2>/dev/null	|| :
fi

%pre tinydns
if [ -z "`id -u %{TinyUser} 2>/dev/null`" ]; then
	/usr/sbin/useradd -c "djbdns TinyDns"  -d "%{_localstatedir}/lib/tinydns" -g "%{DjbGroup}" -M -s /sbin/nologin "%{TinyUser}" 2>/dev/null	|| :
fi

%pre rbldns
if [ -z "`id -u %{RblUser} 2>/dev/null`" ]; then
	/usr/sbin/useradd -c "djbdns RBLDNS"  -d "%{_localstatedir}/lib/rbldns" -g "%{DjbGroup}" -M -s /sbin/nologin "%{RblUser}" 2>/dev/null		|| :
fi

%pre walldns
if [ -z "`id -u %{WallUser} 2>/dev/null`" ]; then
	/usr/sbin/useradd -c "djbdns WallDns"  -d "%{_localstatedir}/lib/walldns" -g "%{DjbGroup}" -M -s /sbin/nologin "%{WallUser}" 2>/dev/null	|| :
fi



#######################################################################
#######################################################################
%post dnscache
# Add on first install
if [ "$1" -eq 1 ]; then
     /sbin/service svscan add "%{_localstatedir}/%{name}/dnscache"
fi
exit 0


%post dnslog
## FUTURE USE

# For now, do NOT add the djbdns script via chkconfig
# we want people to be using the svscan rules directly
exit 0


#######################################################################
#######################################################################
%preun dnslog
if [ "$1" -eq 0 ]; then
    /sbin/chkconfig --del djbdns	|| :
fi

%preun dnscache
if [ "$1" -eq 0 ]; then
    /sbin/service svscan delete dnscache || :
    rm -f %{_localstatedir}/lib/dnscache/seed
    rm -fR "%{_localstatedir}/%{name}/dnscache/supervise" "%{_localstatedir}/%{name}/dnscache/log/supervise"
fi

%preun axfrdns
if [ "$1" -eq 0 ]; then
    /sbin/service svscan delete axfrdns || :
    rm -fR "%{_localstatedir}/%{name}/axfrdns/supervise" "%{_localstatedir}/%{name}/axfrdns/log/supervise"
fi

%preun tinydns
if [ "$1" -eq 0 ]; then
    /sbin/service svscan delete tinydns || :
    rm -fR "%{_localstatedir}/%{name}/tinydns/supervise" "%{_localstatedir}/%{name}/tinydns/log/supervise"
fi

%preun rbldns
if [ "$1" -eq 0 ]; then
    /sbin/service svscan delete rbldns || :
    rm -fR "%{_localstatedir}/%{name}/rbldns/supervise" "%{_localstatedir}/%{name}/rbldns/log/supervise"
fi

%preun walldns
if [ "$1" -eq 0 ]; then
    /sbin/service svscan delete walldns || :
    rm -fR "%{_localstatedir}/%{name}/walldns/supervise" "%{_localstatedir}/%{name}/walldns/log/supervise"
fi



#######################################################################
#######################################################################
%postun dnslog
if [ "$1" -eq 0 ]; then 
    /usr/sbin/userdel "%{LogUser}"		>/dev/null
fi
exit 0

%postun dnscache
if [ "$1" -ge 1 ]; then 
   /sbin/service svscan condrestart dnscache	>/dev/null
else
   /usr/sbin/userdel "%{CacheUser}"		>/dev/null
fi
exit 0

%postun axfrdns
if [ "$1" -ge 1 ]; then 
     /sbin/service svscan condrestart axfrdns	>/dev/null
fi
exit 0

%postun tinydns
if [ "$1" -ge 1 ]; then 
     /sbin/service svscan condrestart tinydns	>/dev/null
else
     /usr/sbin/userdel "%{TinyUser}"		>/dev/null
fi
exit 0

%postun rbldns
if [ "$1" -ge 1 ]; then 
     /sbin/service svscan condrestart rbldns	>/dev/null
else
     /usr/sbin/userdel "%{RblUser}"		>/dev/null
fi
exit 0

%postun walldns
if [ "$1" -ge 1 ]; then 
     /sbin/service svscan condrestart walldns	>/dev/null
else
     /usr/sbin/userdel "%{WallUser}"		>/dev/null
fi
exit 0


#######################################################################
#######################################################################

%files
%defattr(-,root,root)
%doc CHANGES TODO README*

/bin/dnsfilter
/bin/dnsip
/bin/dnsipq
/bin/dnsmx
/bin/dnsname
/bin/dnsq
/bin/dnsqr
/bin/dnstxt
/sbin/dnsfilter
/sbin/dnstrace
/sbin/dnstracesort
/sbin/random-ip
/usr/sbin/dnsfilter
/usr/sbin/dnstrace
/usr/sbin/dnstracesort
/usr/sbin/random-ip
%{_mandir}/man1/dns*
%{_mandir}/man5/qualification.5.gz
%attr(644,root,root) %config(noreplace)	%ghost	%{_sysconfdir}/dnsrewrite


%files dnslog
%defattr(-,root,root)
%attr(755,root,root) %dir %{_localstatedir}/%{name}
%attr(755,root,root)	%{_initrddir}/%{name}
%attr(755,root,root)	%{_sbindir}/djbdnsctl


%files dnscache
%defattr(-,root,root)
%{_sbindir}/dnscache*
%{_mandir}/man8/dnscache*
%config			%{_sysconfdir}/dnsroots.global
%config(noreplace)	%ghost	%{_sysconfdir}/dnsroots.local


%attr(644,root,root)		%config(noreplace) %{_sysconfdir}/sysconfig/dnscache
%attr(755,root,root)		%config %{_localstatedir}/%{name}/dnscache/log/run
%attr(755,root,root)		%config %{_localstatedir}/%{name}/dnscache/run
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/dnscache/log
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/dnscache


%attr(755,%{LogUser},%{DjbGroup})	%{_localstatedir}/log/dnscache

%dir				%{_localstatedir}/lib/dnscache
%dir				%{_localstatedir}/lib/dnscache/ip
%dir				%{_localstatedir}/lib/dnscache/servers
%config(missingok)		%{_localstatedir}/lib/dnscache/ip/*
%config(noreplace)		%{_localstatedir}/lib/dnscache/servers/@

%attr(755,%{CacheUser},%{DjbGroup})	%{_localstatedir}/lib/dnscache/dump
%attr(755,%{CacheUser},%{DjbGroup})	%dir %{_localstatedir}/cache/dnscache
%attr(644,%{CacheUser},%{DjbGroup})	%ghost %{_localstatedir}/cache/dnscache/cache.data



%files axfrdns
%defattr(-,root,root)
%{_sbindir}/axfrdns*
%{_mandir}/man8/axfrdns*

%attr(644,root,root)	%ghost	%config(noreplace) %{_sysconfdir}/tcprules.d/axfrdns.cdb
%attr(644,root,root)		%config(noreplace) %{_sysconfdir}/tcprules.d/axfrdns
%attr(644,root,root)		%config(noreplace) %{_sysconfdir}/sysconfig/axfrdns
%attr(755,root,root)		%config %{_localstatedir}/%{name}/axfrdns/log/run
%attr(755,root,root)		%config %{_localstatedir}/%{name}/axfrdns/run
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/axfrdns/log
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/axfrdns

%attr(755,%{LogUser},%{DjbGroup})	%{_localstatedir}/log/axfrdns



%files tinydns
%defattr(-,root,root)
%doc TINYDNS
%{_sbindir}/tinydns*
%{_sbindir}/add-*
%{_sbindir}/axfr-get
%{_mandir}/man1/tinydns*
%{_mandir}/man8/tinydns*
%{_mandir}/man8/axfr-get.8.gz

%attr(644,root,root)		%config(noreplace) %{_sysconfdir}/sysconfig/tinydns
%attr(755,root,root)		%config %{_localstatedir}/%{name}/tinydns/log/run
%attr(755,root,root)		%config %{_localstatedir}/%{name}/tinydns/run
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/tinydns/log
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/tinydns

%attr(755,%{LogUser},%{DjbGroup})	%{_localstatedir}/log/tinydns


%config(noreplace) 	%ghost	%{_localstatedir}/lib/tinydns/data.cdb
%config(noreplace)		%{_localstatedir}/lib/tinydns/data

%dir %{_localstatedir}/lib/tinydns
     %{_localstatedir}/lib/tinydns/Makefile



%files rbldns
%defattr(-,root,root)
%{_sbindir}/rbldns*
%{_mandir}/man8/rbldns*

%attr(644,root,root)		%config(noreplace) %{_sysconfdir}/sysconfig/rbldns
%attr(755,root,root)		%config %{_localstatedir}/%{name}/rbldns/log/run
%attr(755,root,root)		%config %{_localstatedir}/%{name}/rbldns/run
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/rbldns/log
%attr(755,root,root)		%dir %{_localstatedir}/%{name}/rbldns

%attr(755,%{LogUser},%{DjbGroup})	%{_localstatedir}/log/rbldns


%config(noreplace)	%ghost	%{_localstatedir}/lib/rbldns/data.cdb
%config(noreplace)		%{_localstatedir}/lib/rbldns/data

%dir %{_localstatedir}/lib/rbldns
     %{_localstatedir}/lib/rbldns/Makefile



%files walldns
%defattr(-,root,root)
%{_sbindir}/walldns*
%{_mandir}/man8/walldns*

%attr(644,root,root)		 %config(noreplace) %{_sysconfdir}/sysconfig/walldns
%attr(755,root,root)		 %config %{_localstatedir}/%{name}/walldns/log/run
%attr(755,root,root)		 %config %{_localstatedir}/%{name}/walldns/run
%attr(755,root,root)		 %dir %{_localstatedir}/%{name}/walldns/log
%attr(755,root,root)		 %dir %{_localstatedir}/%{name}/walldns
%attr(755,root,root)		 %dir %{_localstatedir}/lib/walldns

%attr(755,%{LogUser},%{DjbGroup})	%{_localstatedir}/log/walldns



#######################################################################
%changelog
* Mon Sep 30 2013 Japheth Cleaver <cleaver@terabithia.org> 1.05-16
- rebuild with current dietlibc

* Wed Jan 09 2013 Japheth Cleaver <cleaver@terabithia.org> 1.05-15
- fix env variable bug in log script
- rebuild with current dietlibc
- spec file cleanup

* Thu Mar 03 2011 Japheth Cleaver <jcleaver@soe.sony.com> 1.05-14.4
- revise axfrdns supervise script
- add tinydns convenience scripts

* Tue Mar 01 2011 Japheth Cleaver <jcleaver@soe.sony.com> 1.05-14.3
- more spec file re-factoring for a much cleaner design
- dnscache: root/ip/ files now marked missingok so they aren't replaced
- add ghost /etc/dnsrewrite config (man qualification for info)
- fix bugs in all supervise scripts
- remove spurious lib directory for axfrdns

* Mon Feb 28 2011 Japheth Cleaver <jcleaver@soe.sony.com> 1.05-14
- update dnsroots.global file with current root NS addresses
- move logging user to subpackage
- add tinydns, axfrdns, and walldns packages
- move supervise directories from /etc to /var/djbdns
- move daemons from main package to appropriate subpackages to remove
  unneeded dependencies for the simple djbdns tools
- move dnscache seed generation to supervise script
- move dnsfilter and dnstrace from /usr/sbin to /sbin
- rebuilt with dietlibc

* Fri Feb 18 2011 Japheth Cleaver <jcleaver@soe.sony.com> 1.05-12.1
- SPEC file cleanups and allow dietlibc to be specified on build line

* Tue Jun 07 2010 Japheth Cleaver <jcleaver@soe.sony.com> 1.05-12
- rebuild for RHEL 6 beta
- add dnsnamex and dnsqrx commands
- add rbldns subpackage
- remove (d)ash dependency

* Wed Jan 9 2008 Japheth Cleaver <cleaver@redwire.net> 1.05-11
- add dist catch to build on rh9, which doesn't allow mixed case users
- ensure we can build without qmail being present
- add special HISPEED flag to log dnscache to /dev/shm

* Wed May 9 2007 Japheth Cleaver <cleaver@redwire.net> 1.05-7
- add a number of patches from 
  http://homepages.tesco.net./~J.deBoynePollard/Softwares/djbdns/
- buglet in post script for dnscache

* Thu May 3 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.05-5
- build using dietlibc
- update qmail+djbdns patch for compatibility with qmail+spf
- minor package update
- use svscanctl to do our service starts and stops
- move some dnstesting utils to from /usr/sbin to /bin

* Mon Jan 30 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.05-3
- Add qmail+djbdns data and build (for use by qmail package later)
- Add walldns package

* Tue Nov 29 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.05-2
- Split into different packages for djbdns and dnscache
- dnscache: Log to /var/log/dnscache
- dnscache: "root" for ip/servers at /var/lib/dnscache

* Tue Mar 08 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.05-1
- Spec file created
